
#include <stdio.h>
#include "micro_frc.h"
//#include "servo.h"
#include "uart1.h"
#include "timer.h"
#include "sensor_spi.h"
#include "ahrs.h"
#include "adc.h"

#include <math.h>



v_t			angles; // euler angles from kalman process
//v_t			accels;	// vector of measured accelerations
f_t			agpsx;	// estimated accellerations from gps
f_t			agpsy;
f_t			agpsz;
//f_t			g;		// gravity magnitude calculated from accel sensors


int main ()
{			
	float dt; // loop time in seconds
	int i; //for loops

	//float dummy;

	microcontroller_init();
	
//	init_timer1();
//	init_timer2();
	init_timer4(); //used for dt
	
//	init_servos() ; 	// initialize servo capture and receive

	uart1_open(57600L);
	
	adc_open();
	
	

// assume we're steady state, wait to stabilize and get some static values
	for (i=0; i < 100; i++) 
	{
	adc_start();
	microcontroller_delay_ms(2);
	}
	
// get a static value for gravity from accel sensors
// g = sqrt( accelero_x() * accelero_x() + accelero_y() * accelero_y() + accelero_z() * accelero_z());

	ahrs_init(accelero_x(), accelero_y(), accelero_z(),gyro_roll_rps(),gyro_pitch_rps(),gyro_yaw_rps(), 0 );  // ax, ay, az, roll rate, pitch rate, yaw rate,heading
	//ahrs_init(0.,0.,-9.8,0.,0.,0.,.0);  // ax, ay, az, pbias,qbias,rbias,heading compass or gps
				
	adc_start();
	microcontroller_delay_ms(10);

	while (1)			// main loop
	{

	dt = dt_seconds();			
						
/*
// calibrated sensor data
	printf( "%9.3f %9.3f %9.3f  %9.3f %9.3f %9.3f  %9.5f\n\r",
		accelero_x(),
		accelero_y(),
		accelero_z(),
		gyro_roll_dps(),
		gyro_pitch_dps(),
		gyro_yaw_dps(),
		dt);
*/

	ahrs_step( angles, dt, gyro_roll_rps(), gyro_pitch_rps(), gyro_yaw_rps(), accelero_x(), accelero_y(), accelero_z(), 0 );
	//ahrs_step( angles, dt, gyro_roll_rps(), gyro_pitch_rps(), gyro_yaw_rps(), 0., 0., -9.8, 0 );
	//ahrs_step( angles, dt, 0., 0., 0., accelero_x(), accelero_y(), accelero_z(), 0 );
	//ahrs_step( angles, dt, 0., 0., 0., 0., 0. ,-9.81, 0 ); 	// rad/sec2 m/sec2 and radians
																// accels don't have to be scaled
																// 1 deg per sec is .01745
/*
// euler angles from initial accelerometer readings only
		accel2euler(
		angles,
		accelero_x(),
		accelero_y(),
		accelero_z(),
		0
	);
*/
	// artificial horizon display	
	printf( "p%9.3f %9.3f %9.3f %9.6f\n\r",
			angles[0],
			angles[1],
			angles[2],
			dt
		);	


	// restart adc
	adc_start();
	microcontroller_delay_ms(10);

/*	// general angles display
	printf( "p%9.3fq%9.3fr%9.3ft%9.6f\n\r",
			rad_to_deg(angles[0]),
			rad_to_deg(angles[1]),
			rad_to_deg(angles[2]),
			dt
		);
*/


		
	
		


/*
printf( "angles %9.3f%9.3f%9.3f\n",
			rad_to_deg(angles[0]),
			rad_to_deg(angles[1]),
			rad_to_deg(angles[2])
		);
*/

// do I need to run this before the kalman steps?
		//agpsx=0.; // zeroize for testing
		//agpsy=0.;
		//agpsz=0.;
		//body_to_ecef(angles,accelero_x(), accelero_y(), accelero_z(),agpsx,agpsy,agpsz); // correct angles to ecef reference frame based on gps acceleration
		//body_to_ecef(angles,0, 0, 0,agpsx,agpsy,agpsz); 


/*		printf( "%9.3f%9.3f%9.3f   %9.3f%9.3f%9.3f  %9.3f%9.3f%9.3f\n",
			rad_to_deg(angles[0]),
			rad_to_deg(angles[1]),
			rad_to_deg(angles[2]),

			rad_to_deg(biased_roll),
			gyro_pitch_dps(),
			gyro_yaw_dps(),

			accelero_x(),
			accelero_y(),
			accelero_z()

		);
*/


/*
printf( "a ecef %9.3f%9.3f%9.3f\n\r",
			rad_to_deg(angles[0]),
			rad_to_deg(angles[1]),
			rad_to_deg(angles[2])
		);
*/
		
	

	
	} // end while


	return 0 ;
}
	
